<?php

if (!defined('ABSPATH')) {
  die('-1');
}

/**
 * Fetch value from Database and output the data to view
 * @param $db_status
 * @param $message
 */
function populate_data($db_status, $message)
{
  if ($db_status == 'success') {
    $rows = bc_rb_get_all_row();
    if ($rows) {
      $content = loop_data($rows);
      echo json_encode(array('content' => $content, 'message' => $message, 'type' => 'success'));
      die();
    }
  } else {
    echo json_encode(array('error' => 'Something went wrong, Please try again', 'type' => 'error'));
    die();
  }
}


/**
 * Loop the data based on Banner type (Script or Upload)
 * @param $rows
 * @return string
 */
function loop_data($rows)
{
  $content = '';
  foreach ($rows as $row) {
    if ($row->banner_type == 'upload') {
      $content .= '<div class="row single_upload">
<form>
<input type="hidden" name="banner_type" value="' . esc_attr($row->banner_type) . '" />
<input type="hidden" name="banner_id" class="form-control banner_id" value="' . $row->id . '"/>
  <div class="col-md-2">
    <div class="col-md-12 padding_bottom_20">
      <div class="no_image" readonly>
        <img width=120 height=120 src=" ' . $row->file_url . ' ">
      </div>
    </div>
    </div>
    <div class="col-md-8">
    <div class="col-md-6">
      <input readonly type="text" name="file_url_link" class="form-control file_url_link" placeholder="Upload Image" value="' . $row->file_url . '"/>
     </div>
     <div class="col-md-6">
      <input readonly type="text" name="file_description" class="form-control file_description" placeholder="File Description" value="' . $row->file_description . '"/>
      </div>
      <div class="col-md-12 padding_top_10">
      <input readonly type="text" name="external_link" class="bc_rb_external_link form-control" placeholder="External Link" value="' . $row->external_link . '" />
      </div>
      <div class="col-md-3 padding_top_10">
      <div class="input-group">
      <input readonly name="width" type="number" class="form-control width" placeholder="Width in px" value="' . $row->width . '" />
      <span class="input-group-addon" >px</span>
      </div>
      </div>
      <div class="col-md-3 padding_top_10">
      <div class="input-group">
      <input readonly name="height" type="number" class="form-control height" placeholder="Height in px" value="' . $row->height . '" />
      <span class="input-group-addon" >px</span>
      </div>
      </div>
      <div class="col-md-3 padding_top_10">
      <div class="checkbox">
      <label>
      <input disabled="disabled"' . $row->automatic . ' class="automatic" type="checkbox" name="automatic" value="checked"> Theme Based </label>
      </div>
      </div>
      <div class="col-md-3 padding_top_10">
      <div class="input-group">
      <div class="dropdown">
      ' . bc_rb_drop_down('category', bc_rb_get_category_by_array(), $row->category, 'disabled', 'category') . '
      </div>
      </div>
      </div>
      </div>
      <div class="col-md-2">
      <div class="col-md-12">
      <button class="btn btn-primary bc_rb_button_edit">Edit</button>
      </div>
      <div class="col-md-12 padding_top_20">
      <button class="btn btn-danger bc_rb_button_delete_by_id">Delete</button>
      </div>
      </div>
      </form>
      </div>';
    }
    if ($row->banner_type == 'script') {
      $content .= '<div class="row single_upload">
<form>
<input type="hidden" name="banner_type" value="' . esc_attr($row->banner_type) . '" />
<input type="hidden" name="banner_id" class="form-control banner_id" value="' . $row->id . '"/>
<div class="col-md-8">
<textarea readonly name="file_url_link" class="file_url_link_textarea form-control" rows="5" placeholder="Please paste the code here">' . esc_js($row->file_url) . '</textarea>
</div>
<div class="col-md-2">
      <div class="input-group">
      <div class="dropdown">
      ' . bc_rb_drop_down('category', bc_rb_get_category_by_array(), $row->category, 'disabled', 'category') . '
      </div>
      </div>
      </div>
<div class="col-md-2">
      <div class="col-md-12">
      <button class="btn btn-primary bc_rb_button_edit">Edit</button>
      </div>
      <div class="col-md-12 padding_top_20">
      <button class="btn btn-danger bc_rb_button_delete_by_id">Delete</button>
      </div>
      </div>
</form>
</div>';
    }
  }

  return $content;
}

/**
 * Check and return Banner Model and type based on give banner type
 * @param $post
 * @return mixed
 */
function bc_rb_check_banner_model_and_type($post)
{
  $banner = array();
  $banner['type'] = ($post['banner_type'] == 'upload') ? bc_rb_upload_banner_model($post) : bc_rb_script_banner_model($post);
  $banner['option'] = ($post['banner_type'] == 'upload') ? bc_rb_upload_banner_option_model() : bc_rb_script_banner_option_model();

  return $banner;
}

function get_random_banner_option_value()
{
  $options = unserialize(get_option('bc_rb_setting_options'));
  return $options;
}

function bc_rb_open_case()
{
  $option_value = get_random_banner_option_value();
  if ($option_value['open'] == 'checked') {
    return 'target="_blank"';
  }
  return '';
}

function bc_rb_populate_category()
{
  $rows = bc_rb_get_all_category();
  if ($rows) {
    $content = bc_rb_loop_category($rows);
    echo json_encode(array('content' => $content, 'message' => 'Successfully Saved', 'type' => 'success'));
    exit();
  }
}

function bc_rb_loop_category($rows)
{
  $content = '';
  foreach ($rows as $row) {
    $content .= '<div class="row single_category padding_top_10">
      <form>
      <div class="col-md-8">
      <input type="hidden" name="category_id" value="' . $row->id . '">
      <input type="text" name="category" class="category_input form-control" value="' . $row->category . '" readonly />
      </div>
      <div class="col-md-4 category_button">';
    if ($row->category != 'default') {
      $content .= '<button class="btn btn-primary bc_rb_button_edit">edit</button>
      <button class="btn btn-danger bc_rb_button_delete_by_id">Delete</button>';
    }
    $content .= '</div>
      </form>
      </div>';
  }
  return $content;
}

function bc_rb_get_category_by_array()
{
  $collections = bc_rb_get_all_category();
  $category = array();
  foreach ($collections as $collection) {
    $category[$collection->category] = $collection->category;
  }
  return $category;
}

function bc_rb_get_category_by_array_js($selected = '')
{
  return bc_rb_loop_drop_down($selected, array_reverse(bc_rb_get_category_by_array()));
  exit();
}

function bc_rb_get_enable_slider($selected = '')
{
  return bc_rb_loop_drop_down($selected, bc_rb_get_yes_or_no_values());
  exit();
}

function bc_rb_get_slider_autoplay($selected = '')
{
  return bc_rb_loop_drop_down($selected, bc_rb_get_true_or_false_values());
  exit();
}

function bc_rb_get_slider_loop($selected = '')
{
  return bc_rb_loop_drop_down($selected, bc_rb_get_true_or_false_values());
  exit();
}

function bc_rb_get_slider_delay($selected = '')
{
  return bc_rb_loop_drop_down($selected, bc_rb_get_slider_delay_values());
}

function bc_rb_loop_drop_down($selected, $values)
{
  $value = '';
  foreach ($values as $single) {
    $is_selected = '';
    if ($selected == $single) {
      $is_selected = 'selected';
    }
    $value .= '<option value="' . $single . '" ' . $is_selected . '>' . ucfirst($single) . '</option>';
  }
  return $value;
}

function bc_rb_get_unique_banner_from_session($category)
{
  session_start();

  if (!isset($_SESSION['bc_rb_category_session']) || !is_array($_SESSION['bc_rb_category_session'])) {
    $_SESSION['bc_rb_category_session'] = array();
  }

  $get_all_banner = bc_rb_get_all_banners($category);

  if ($get_all_banner) {
    if (count($_SESSION['bc_rb_category_session']) == count($get_all_banner)) {
      $_SESSION['bc_rb_category_session'] = array();
    }
    $rb_bc_pending = bc_rb_check_value_in_session($get_all_banner);
    return $rb_bc_pending;
  }
  return '';

}

function bc_rb_check_value_in_session($get_all_banner)
{

  if (empty($_SESSION['bc_rb_category_session'])) {
    array_push($_SESSION['bc_rb_category_session'], $get_all_banner[0]->id);
    return $get_all_banner[0];
  }
  foreach ($get_all_banner as $index => $get_only) {
    if (!in_array($get_only->id, $_SESSION['bc_rb_category_session'])) {
      array_push($_SESSION['bc_rb_category_session'], $get_only->id);
      return $get_only;
    }
  }
}