<?php

if (!defined('ABSPATH')) {
  die('-1');
}

/**
 * Return Current Time
 */
function bc_rb_get_current_date($format = 'd-m-Y H:i:s')
{
  return date($format);
}

/**
 * Convert Script to HTML for Script Banner
 * @param $string
 * @return mixed
 */
function bc_rb_convert_to_html($string)
{
  return str_replace('\"', '"', html_entity_decode($string));
}

/**
 * Show Payment Details for Paid user else PayPal Donation button
 * @return string
 */
function bc_rb_show_payment_details()
{
  return '<div class="paypal_donation_button"><img width="150px" height="100px" src="' . plugins_url("/assets/images/paypal.png", BC_RB_PLUGIN) . '" alt="Buffercode PayPal Donation Button"/></div>';

}

/**
 * Check is User did PayPal Donation
 * @return bool
 */
function bc_rb_is_paid()
{
  $paid_status = get_option('bc_rb_payment_info');
  if ($paid_status == 'no' || strlen($paid_status) == 8) {
    return false;
  }
  return true;
}

/**
 * get user display name
 * @return string
 */
function bc_rb_get_user_display_name()
{
  global $current_user;
  return $current_user->display_name;
}

/**
 * loader to show on processing request
 * @return string
 */
function bc_rb_loader()
{
  return '<div id="preview-area">
        <div class="spinner_circle hide">
            <div class="double-bounce1"></div>
            <div class="double-bounce2"></div>
        </div>
    </div>';
}

/**
 * Echo Transaction Details on Success
 * @param $request
 */
function bc_rb_on_success_payment($request)
{
  if (isset($request['success']) && isset($request['tid'])) {
    update_option('bc_rb_payment_info', $request['tid']);
    echo '<div class="alert alert-success">
  <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
  <strong>Success!</strong> Thanks for your Donation. Your Transaction ID : ' . $request['tid'] . '
</div>';
  } else if (isset($request['success'])) {
    echo '<div class="alert alert-danger">
      <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
      <strong>Cancelled!</strong> Oh! You have cancelled the Transaction
    </div>';
  }
}

/**
 * Select drop value from give value
 */
function bc_rb_drop_down($name, $options, $selected = null, $onchange = null, $class = null)
{
  $options = (array)$options;
  $dropdown = '<select name="' . $name . '" class="form-control ' . $class . '"' . $onchange . '>' . "\n";

  foreach ($options as $key => $option) {
    $select = $selected == $key ? ' selected="true" selected' : "";
    $dropdown .= sprintf(
        "<option value=\"%s\"%s>%s</option>\r\n", htmlspecialchars($key), $select, ucfirst(htmlspecialchars($option))
    );
  }

  $dropdown .= '</select>' . "\n";

  return $dropdown;
}

function bc_rb_get_yes_or_no_values()
{
  return array(
      'No' => 'No',
      'Yes' => 'Yes'
  );
}

function bc_rb_get_true_or_false_values()
{
  return array(
      'true' => 'true',
      'false' => 'false'
  );
}

function bc_rb_get_slider_animation_values()
{
  return array(
      'horizontal' => 'horizontal',
      'vertical' => 'vertical',
      'fade' => 'fade'
  );
}

function bc_rb_get_slider_delay_values()
{
  return array(
      '3000' => '3000',
      '4000' => '4000',
      '5000' => '5000',
      '6000' => '6000',
      '7000' => '7000',
      '10000' => '10000',
      '15000' => '15000',
      '20000' => '20000'
  );
}