<?php
add_action('bc_rb_upgrade', 'bc_rb_db_update', 10, 2);

function bc_rb_db_update($new_version, $old_version)
{
  if ((version_compare($old_version, '0', '==')) || (version_compare($old_version, '1.3', '<='))) {
    bc_rb_update_from_old();
    version_2_0_to_2_2();
    version_2_2_greater();
  }

  if (version_compare($old_version, '2.0', '>=') && version_compare($old_version, '2.2', '<')) {
    version_2_0_to_2_2();
    version_2_2_greater();
  }

  if (version_compare($old_version, '2.2', '>=')) {
    version_2_2_greater();
  }

}

function version_2_0_to_2_2()
{
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
  global $wpdb;
  $bc_random_banner = $wpdb->prefix . BC_RB_RANDOM_BANNER_DB;
  $wpdb->query("ALTER TABLE $bc_random_banner ADD automatic VARCHAR(255) NOT NULL DEFAULT 'checked' AFTER banner_type, ADD width MEDIUMINT(9) NOT NULL  AFTER automatic, ADD height MEDIUMINT(9) NOT NULL AFTER width");
}


function version_2_2_greater()
{
  require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
  global $wpdb;
  $post = array('category' => 'default');
  $bc_random_banner_category = $wpdb->prefix . BC_RB_RANDOM_BANNER_CATEGORY;
  $bc_random_banner = $wpdb->prefix . BC_RB_RANDOM_BANNER_DB;

  // Add new Category Table
  $wpdb->query("CREATE TABLE IF NOT EXISTS $bc_random_banner_category (
		id mediumint(9) NOT NULL AUTO_INCREMENT,
		category varchar (255) NOT NULL,
		created VARCHAR (255)  DEFAULT '0000-00-00 00:00:00' NOT NULL,
		PRIMARY KEY id (id)
	)");

 // Add Category column to random banner table
  $wpdb->query("ALTER TABLE $bc_random_banner ADD category VARCHAR(255) NOT NULL DEFAULT 'default' AFTER height");

  bc_rb_add_new_category($bc_random_banner_category, $post);
}